package j2eecourses;

import java.io.IOException;

import javax.mail.Address;
import javax.mail.Message;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class MailServlet extends HttpServlet{

    public void doGet(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException {
        
        Session sess = lookupSession();
        sendMail(sess);
        response.setContentType("text/html");
        response.getWriter().println("Message sent");        
    }

    private void sendMail(Session sess) {
        try {
            Message message = new MimeMessage(sess);
            message.setText("Hallo von J2EE");
            Address address = 
                new InternetAddress("gloegl@fmi.uni-passau.de");
            message.setRecipient(Message.RecipientType.TO, address);
            message.setFrom(address);
            Transport.send(message);   
        } catch (Exception e) {
            throw new RuntimeException(e);
        } 
        
    }

    private Session lookupSession() {
        try {
            InitialContext context = new InitialContext();
            Session sess = (Session) 
                context.lookup("java:comp/env/mail/Mailversender");
            return sess;
        } catch (NamingException e) {
            throw new RuntimeException(e);
        }
    }
}
