package j2eecourses;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;

public class SimpleServlet extends HttpServlet {
    
    public static final String HTML_HEADER = "<html><head><title>Tolle Seite</title></head><body>";
    public static final String HTML_BODY = "</body></html>";
    
    
    public void doGet(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException {
            
        response.setContentType("text/html");         
        DataSource ds = lookupDS();
        List books = queryDB(ds);
        printBooks(books, response.getWriter());
    }

    private void printBooks(List books, PrintWriter writer) {
        writer.println(HTML_HEADER);
        for (Iterator iter = books.iterator(); iter.hasNext();) {
            Book book = (Book) iter.next();
            writer.println(book.getTitle() + "<br>");
        }
        writer.println(HTML_BODY);
    }

    private List queryDB(DataSource ds) {
        try {
            Connection conn = ds.getConnection();
            Statement stmnt = conn.createStatement();
            ResultSet rs = stmnt.executeQuery("SELECT * FROM books");
            List result = new ArrayList();
            while (rs.next()) {
                result.add(new Book(rs.getString("title")));
            }
            stmnt.close(); conn.close();
            return result;
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
    }

    private DataSource lookupDS() {
        try {
            InitialContext context = new InitialContext();
            return (DataSource) 
                context.lookup("java:comp/env/jdbc/KrasseDS");
        } catch (NamingException e) {
            throw new RuntimeException(e);
        }
    }
}
